%     FASTENER DOCTOR - программа для лечения и конвертации крепежа
%     Copyright (C) 2018  Михаил Козлов
%     Сайт проекта: <http://www.fastenerdoctor.ru/>
%     Адрес электронной почты для связи с разработчиком:
%     <doctor.fastener@gmail.com>
% 
%     Эта программа является свободным программным обеспечением: Вы можете
%     распространять ее и/или изменять, соблюдая условия Универсальной общественной
%     лицензии GNU, опубликованной Фондом свободного программного обеспечения,
%     либо редакции 3, либо (на Ваше усмотрение) любой редакции, выпущенной позже.
% 
%     Эта программа распространяется в надежде на то, что она окажется полезной,
%     но БЕЗ КАКИХ-ЛИБО ГАРАНТИЙ, включая даже подразумеваемую гарантию ТОВАРНОЙ ПРИГОДНОСТИ,
%     либо ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Ознакомьтесь с Универсальной общественной
%     лицензией GNU для получения более подробной информации.
% 
%     Вы должны были получить копию Универсальной общественной лицензии GNU
%     вместе с этой программой. Если Вы ее не получили, то перейдите по адресу:
%     <http://www.gnu.org/licenses/>.
% 
%     This program is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with this program.  If not, see <https://www.gnu.org/licenses/>.

function Plot_Fastener(Fastener_Index, Bolt_Shank_Length_Multiplier)

global ErrCode;
global Global_equivalence_tolerance;

global db_Next_Curve_Number;

global DB_FASTENERS;

% Получение оси болта
[Axis_Point_1, Axis_Point_2, Axis_vector] = Get_Fastener_Axis(Fastener_Index);

if (ErrCode < 0)
    return;
end

% Получение точки срединной поверхности первого яруса
Point_1 = Get_Plate_Midsurf_Point(Fastener_Index, 1, Axis_Point_1, Axis_Point_2, Axis_vector);

if (ErrCode < 0)
    return;
end

% Получение точки срединной поверхности последнего яруса
Point_2 = Get_Plate_Midsurf_Point(Fastener_Index, DB_FASTENERS{Fastener_Index}.N_layers, Axis_Point_1, Axis_Point_2, Axis_vector);

if (ErrCode < 0)
    return;
end

% Длина стержня болта между срединными поверхностями крайних ярусов
Bolt_length = norm(Point_1 - Point_2);

if (Bolt_length < Global_equivalence_tolerance)
    fprintf (1, '\nОшибка: нулевая длина болта %i !\n', Fastener_Index);
    ErrCode = -1;
    return;
end

% Получение знака
Sign = sign(dot(Point_1 - Point_2, Axis_vector));

% Точки начала и конца стержня болта с учетом множителя длины
Point_1 = Point_1 + (Bolt_Shank_Length_Multiplier - 1)/2 * Bolt_length * Axis_vector * Sign;
Point_2 = Point_2 - (Bolt_Shank_Length_Multiplier - 1)/2 * Bolt_length * Axis_vector * Sign;

% Создание кривой
Append_To_Output(PCL_Curve_Create_2P(Point_1, Point_2));
db_Next_Curve_Number = db_Next_Curve_Number + 1;
